# ASCII-table

| DEC  | OCT  | HEX  | BIN      | Character                  |
|------|------|------|----------|----------------------------|
|    0 |  000 | 00   | 00000000 | NUL (null)                 |
|    1 |  001 | 01   | 00000001 | SOH (start of heading)     |
|    2 |  002 | 02   | 00000010 | STX (start of text)        |
|    3 |  003 | 03   | 00000011 | ETX (end of text)          |
|    4 |  004 | 04   | 00000100 | EOT (end of transmission   |
|    5 |  005 | 05   | 00000101 | ENQ (enquiry)              |
|    6 |  006 | 06   | 00000110 | ACK (acknowledge           |
|    7 |  007 | 07   | 00000111 | BEL (bell)                 |
|    8 |  010 | 08   | 00001000 | BS  (backspace)            |
|    9 |  011 | 09   | 00001001 | HT  (horzintal tab)        |
|   10 |  012 | 0A   | 00001010 | LF  (line feed / newline)  |
|   11 |  013 | 0B   | 00001011 | VT  (vertical tab)         |
|   12 |  014 | 0C   | 00001100 | FF  (form feed / new page) |
|   13 |  015 | 0D   | 00001101 | CR  (carriage return)      |
|   14 |  016 | 0E   | 00001110 | SO  (shift out)            |
|   15 |  017 | 0F   | 00001111 | SI  (shift in)             |
|   16 |  020 | 10   | 00010000 | DLE (data link escape)     |
|   17 |  021 | 11   | 00010001 | DC1 (device control 1)     |
|   18 |  022 | 12   | 00010010 | DC2 (device control 2)     |
|   19 |  023 | 13   | 00010011 | DC3 (device control 3)     |
|   20 |  024 | 14   | 00010100 | DC4 (device control 4)     |
|   21 |  025 | 15   | 00010101 | NAK (negative acknowledge) |
|   22 |  026 | 16   | 00010110 | SYN (synchrnous idle)      |
|   23 |  027 | 17   | 00010111 | ETB (end of trans. block)  |
|   24 |  030 | 18   | 00011000 | CAN (cancel)               |
|   25 |  031 | 19   | 00011001 | EM  (end of medium)        |
|   26 |  032 | 1A   | 00011010 | SUB (substitute)           |
|   27 |  033 | 1B   | 00011011 | ESC (esacpe)               |
|   28 |  034 | 1C   | 00011100 | FS  (file separator)       |
|   29 |  035 | 1D   | 00011101 | GS  (group separator)      |
|   30 |  036 | 1E   | 00011110 | RS  (record separator)     |
|   31 |  037 | 1F   | 00011111 | US  (unit separator)       |
|   32 |  040 | 20   | 00100000 |     (space)                |
|   33 |  041 | 21   | 00100001 | !                          |
|   34 |  042 | 22   | 00100010 | "                          |
|   35 |  043 | 23   | 00100011 | #                          |
|   36 |  044 | 24   | 00100100 | $                          |
|   37 |  045 | 25   | 00100101 | %                          |
|   38 |  046 | 26   | 00100110 | &                          |
|   39 |  047 | 27   | 00100111 | '                          |
|   40 |  050 | 28   | 00101000 | (                          |
|   41 |  051 | 29   | 00101001 | )                          |
|   42 |  052 | 2A   | 00101010 | *                          |
|   43 |  053 | 2B   | 00101011 | +                          |
|   44 |  054 | 2C   | 00101100 | ,                          |
|   45 |  055 | 2D   | 00101101 | -                          |
|   46 |  056 | 2E   | 00101110 | .                          |
|   47 |  057 | 2F   | 00101111 | /                          |
|   48 |  060 | 30   | 00110000 | 0                          |
|   49 |  061 | 31   | 00110001 | 1                          |
|   50 |  062 | 32   | 00110010 | 2                          |
|   51 |  063 | 33   | 00110011 | 3                          |
|   52 |  064 | 34   | 00110100 | 4                          |
|   53 |  065 | 35   | 00110101 | 5                          |
|   54 |  066 | 36   | 00110110 | 6                          |
|   55 |  067 | 37   | 00110111 | 7                          |
|   56 |  070 | 38   | 00111000 | 8                          |
|   57 |  071 | 39   | 00111001 | 9                          |
|   58 |  072 | 3A   | 00111010 | :                          |
|   59 |  073 | 3B   | 00111011 | ;                          |
|   60 |  074 | 3C   | 00111100 | <                          |
|   61 |  075 | 3D   | 00111101 | =                          |
|   62 |  076 | 3E   | 00111110 | >                          |
|   63 |  077 | 3F   | 00111111 | ?                          |
|   64 |  100 | 40   | 01000000 | @                          |
|   65 |  101 | 41   | 01000001 | A                          |
|   66 |  102 | 42   | 01000010 | B                          |
|   67 |  103 | 43   | 01000011 | C                          |
|   68 |  104 | 44   | 01000100 | D                          |
|   69 |  105 | 45   | 01000101 | E                          |
|   70 |  106 | 46   | 01000110 | F                          |
|   71 |  107 | 47   | 01000111 | G                          |
|   72 |  110 | 48   | 01001000 | H                          |
|   73 |  111 | 49   | 01001001 | I                          |
|   74 |  112 | 4A   | 01001010 | J                          |
|   75 |  113 | 4B   | 01001011 | K                          |
|   76 |  114 | 4C   | 01001100 | L                          |
|   77 |  115 | 4D   | 01001101 | M                          |
|   78 |  116 | 4E   | 01001110 | N                          |
|   79 |  117 | 4F   | 01001111 | O                          |
|   80 |  120 | 50   | 01010000 | P                          |
|   81 |  121 | 51   | 01010001 | Q                          |
|   82 |  122 | 52   | 01010010 | R                          |
|   83 |  123 | 53   | 01010011 | S                          |
|   84 |  124 | 54   | 01010100 | T                          |
|   85 |  125 | 55   | 01010101 | U                          |
|   86 |  126 | 56   | 01010110 | V                          |
|   87 |  127 | 57   | 01010111 | W                          |
|   88 |  130 | 58   | 01011000 | X                          |
|   89 |  131 | 59   | 01011001 | Y                          |
|   90 |  132 | 5A   | 01011010 | Z                          |
|   91 |  133 | 5B   | 01011011 | \[                         |
|   92 |  134 | 5C   | 01011100 | \\                         |
|   93 |  135 | 5D   | 01011101 | \]                         |
|   94 |  136 | 5E   | 01011110 | ^                          |
|   95 |  137 | 5F   | 01011111 | _                          |
|   96 |  140 | 60   | 01100000 | `                          |
|   97 |  141 | 61   | 01100001 | a                          |
|   98 |  142 | 62   | 01100010 | b                          |
|   99 |  143 | 63   | 01100011 | c                          |
|  100 |  144 | 64   | 01100100 | d                          |
|  101 |  145 | 65   | 01100101 | e                          |
|  102 |  146 | 66   | 01100110 | f                          |
|  103 |  147 | 67   | 01100111 | g                          |
|  104 |  150 | 68   | 01101000 | h                          |
|  105 |  151 | 69   | 01101001 | i                          |
|  106 |  152 | 6A   | 01101010 | j                          |
|  107 |  153 | 6B   | 01101011 | k                          |
|  108 |  154 | 6C   | 01101100 | l                          |
|  109 |  155 | 6D   | 01101101 | m                          |
|  110 |  156 | 6E   | 01101110 | n                          |
|  111 |  157 | 6F   | 01101111 | o                          |
|  112 |  160 | 70   | 01110000 | p                          |
|  113 |  161 | 71   | 01110001 | q                          |
|  114 |  162 | 72   | 01110010 | r                          |
|  115 |  163 | 73   | 01110011 | s                          |
|  116 |  164 | 74   | 01110100 | t                          |
|  117 |  165 | 75   | 01110101 | u                          |
|  118 |  166 | 76   | 01110110 | v                          |
|  119 |  167 | 77   | 01110111 | w                          |
|  120 |  170 | 78   | 01111000 | x                          |
|  121 |  171 | 79   | 01111001 | y                          |
|  122 |  172 | 7A   | 01111010 | z                          |
|  123 |  173 | 7B   | 01111011 | {                          |
|  124 |  174 | 7C   | 01111100 | \|                         |
|  125 |  175 | 7D   | 01111101 | }                          |
|  126 |  176 | 7E   | 01111110 | ~                          |
|  127 |  177 | 7F   | 01111111 | DEL (delete)               |
